#include "parti.h"

/*=======================================================================*/
/*
  wrapper for the schedule primitive and it returns the index of this
  particular schedule call
*/

extern TTABLE *get_table_ptr();
extern int register_schedule();
extern int register_table();
extern SCHED *get_sched_ptr();

/*=======================================================================*/
int
  schedule_(local,proc,ndata,maxdim)
int *local, *proc, *ndata, *maxdim;
{
  int index;
  int i;
  SCHED *schedptr;

  for(i=0;i<*ndata;i++)
     local[i]--; 
  schedptr = schedule(local,proc,*ndata, *maxdim);
  index    = register_schedule(schedptr);
  for(i=0;i<*ndata;i++)
     local[i]++;
  return(index);
}

/*=========================================================================*/

void
  free_sched_(schedindex)
int *schedindex;
{
    free_sched((SCHED *)get_sched_ptr(*schedindex));
}
/*=========================================================================*/




void 
  localize_(tabindex,schedindex,global_refs,local_refs,ndata,n_off_proc,
                                 my_size,maxdim)
int *tabindex,*schedindex;
int *ndata,*n_off_proc,*my_size, *maxdim;
int *global_refs,*local_refs;
{
  SCHED *schptr;
  int index,off_proc,i;
  TTABLE *tabptr;
  int  mindex  ;    /* QQQQ */

        
  for(i=0;i<*ndata;i++)
     global_refs[i]--;
  tabptr = (TTABLE *)get_table_ptr(*tabindex);
  localize(tabptr,&schptr,global_refs,local_refs,*ndata,&off_proc,
                                                     *my_size, *maxdim);
  *schedindex = register_schedule(schptr);

  *n_off_proc = off_proc;
  for(i=0;i<*ndata;i++){
     local_refs[i]++;
     global_refs[i]++;
  }
}
/*=======================================================================*/

/* 
   This wrapper has been written for the primitive reglocalize.
*/


void 
  reglocalize_(dist,size,schedindex,global_refs,local_refs,ndata,n_off_proc,
                                 my_size,maxdim)
int *schedindex, *dist, *size ;  
int *ndata,*n_off_proc,*my_size, *maxdim;
int *global_refs,*local_refs;
{
  SCHED *schptr;
  int hops,found;
  int index,off_proc,i,mindex;
        
  for(i=0;i<*ndata;i++)
     global_refs[i]--;

  reglocalize(*dist,*size,&schptr,
          global_refs,local_refs,*ndata,&off_proc,*my_size, *maxdim);

  *schedindex = register_schedule(schptr);
  *n_off_proc = off_proc;

  for(i=0;i<*ndata;i++){
     local_refs[i]++;
     global_refs[i]++;
  }
}
/*=========================================================================*/

void clean_storage_()
{
   /*
    *   clean_storage();
    */
}

/*========================================================================*/

void
  regl_(dist,size,schedindex,global_refs,ndata,maxdim)
int *schedindex, *dist, *size;
int *ndata, *maxdim;
int *global_refs;
{
  SCHED *schptr;
  int hops,found;
  int index,off_proc,i;

  for(i=0;i<*ndata;i++)
     global_refs[i]--;
  regl(*dist,*size,&schptr,global_refs,*ndata,*maxdim);
  *schedindex = register_schedule(schptr);
  for(i=0;i<*ndata;i++){
     global_refs[i]++;
  }
}


/*========================================================================*/
/*    NEW PARTI   WRAPPERS                                                */
/*========================================================================*/

int parti_create_hash_table_ (  size )
int *size;
{
    int index;
    HASHSTR  *hash_table ;

	 hash_table = (HASHSTR *)PARTI_create_hash_table( *size );
	 index      = register_hashstr (hash_table);
         return(index);
}

int parti_create_rep_hash_table_ (  table )
int *table;
{
    int index;
    HASHSTR  *hash_table ;
    TTABLE   *ttable;

	 ttable	    = (TTABLE *) get_table_ptr (*table);
	 hash_table = (HASHSTR *)PARTI_create_rep_hash_table(ttable);
	 index      = register_hashstr (hash_table);
         return(index);
}

/*========================================================================*/
void  parti_free_hash_table_(table_index)
  int *table_index;
  {
     PARTI_free_hash_table((HASHSTR *)get_hashstr(*table_index));
  }

/*========================================================================*/
int parti_make_mask_( stamp )
  int  *stamp ;
  {
      return ( PARTI_make_mask( *stamp ) );
   }
/*========================================================================*/

void parti_hash_(  t_table, h_table, supermask, new_stamp,
                  global_refs, ndata,      my_size,   
		  no_off_proc, no_new_off_proc )
int   *t_table, *h_table,  *supermask, *new_stamp;
int   *global_refs, *ndata,  *my_size,  *no_off_proc, *no_new_off_proc;
{

  TTABLE  *trans_table;
  HASHSTR *hash_table ;
  int  i;

  trans_table =  (TTABLE *)get_table_ptr(*t_table);
  hash_table  =  (HASHSTR *)get_hashstr (*h_table);
  for(i=0;i<*ndata;i++)
	global_refs[i]--;

  PARTI_hash( trans_table,  hash_table,  *supermask,  new_stamp,
   	      global_refs,  *ndata,  *my_size,    no_off_proc, no_new_off_proc); 

  for(i=0;i<*ndata;i++)
	global_refs[i]++;
  
  return ;
}

/*======================================================================*/

void  parti_schedule_ ( h_table, combo_mask, sched, maxdim)

int   *h_table, *combo_mask, *sched, *maxdim ;
{

  HASHSTR *hash_table;
  SCHED   *schedule;

  hash_table  =  (HASHSTR *)get_hashstr (*h_table);
  PARTI_schedule( hash_table,  *combo_mask, &schedule, *maxdim);
  *sched = register_schedule(schedule); 
  return;
}

/*=====================================================================*/

void  parti_incremental_schedule_( h_table, combo_mask, sched, maxdim)
int   *h_table, *combo_mask, *sched, *maxdim ;
{

  HASHSTR *hash_table;
  SCHED   *schedule;

  hash_table  =  (HASHSTR *)get_hashstr (*h_table);
  PARTI_incremental_schedule( hash_table,  *combo_mask, &schedule, *maxdim);
  *sched = register_schedule(schedule); 
  return;
}
/*=====================================================================*/

void  parti_schedule_nc_( h_table, combo_mask, sched, maxdim)
int   *h_table, *combo_mask, *sched, *maxdim ;
{
  HASHSTR *hash_table;
  SCHED   *schedule;

  hash_table  =  (HASHSTR *)get_hashstr (*h_table);
  PARTI_schedule_nc( hash_table,  *combo_mask, &schedule, *maxdim);
  *sched = register_schedule(schedule);
  return;
}

/*=====================================================================*/

void parti_setup_ ()
{
  PARTI_setup();
}

/*==================================================================*/
void  parti_clear_mask_ (hashindex, mask)
int *hashindex, *mask;
{
  HASHSTR *hash_table;

  hash_table  =  (HASHSTR *)get_hashstr (*hashindex);
  PARTI_clear_mask( hash_table, *mask);
  return;
}
/*==================================================================*/

